import 'package:flutter_test/flutter_test.dart';
import 'package:local_value/local_values/local_value.dart';
import 'package:mocktail/mocktail.dart';

import '../mocks.dart';
import '../setups.dart';

void main() {
  final fakeBasePath = ['hi', 'bye', 'basePath'];
  const fakeFileName = 'thisIsFileName';

  setUp(() {
    registerTestFallbackValues();
  });

  group('read', () {
    test('should read primative from json with key "value"', () {});
    test('should call fromJson during load', () {});
    test('should return null on objectContainer.read returns null', () {});

    test('should return T on objectContainer.read returns T', () {});
  });

  group('write', () {
    test('should call toJson on object', () {});
  });

  test('should perform operations at basePath + fileName', () async {
    final MockLocalDataContainer mockLocalDataContainer =
        MockLocalDataContainer();
    final mockLocalDataContainerCreator = MockLocalDataContainerCreator();
    when(() => mockLocalDataContainerCreator.getContainer(any(), any()))
        .thenAnswer((_) async => mockLocalDataContainer);

    final localValue = buildLocalValueWithDependences<String>(
      localDataContainerCreator: mockLocalDataContainerCreator.getContainer,
      basePath: fakeBasePath,
    );

    await localValue.read(fakeFileName);

    expect(
        verify(() =>
                mockLocalDataContainerCreator.getContainer(any(), captureAny()))
            .captured[0],
        'hi/bye/basePath/thisIsFileName.json');
  });
}
